<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Handler_ErrMessages extends Controller_Handler
{
    public function action_getRequests() {
        $this->user->checkAccess(User::RIGHTS_ADMIN);  // todo: is it?

        $data = $this->getReports();
        $data['num'] = count($data) - 1;
        $this->response->body(json_encode($data));
    }

    private function getReports() {
        $query = 'CALL `GetRequests`(0, 1000, :account, "all")';
        return DB::query(Database::SELECT, $query)
            ->param(':account', $this->user->ID)
            ->execute()->as_array();
    }


    public function action_createRequest() {
        $this->user->checkAccess(User::RIGHTS_STUDENT | User::RIGHTS_TEACHER);

        $title = $_POST['title'];
        $text = $_POST['text'];

        // constructing mail body
        $to = 'it.lab.mmcs@gmail.com';

        $ticket = $this->sendNewRequest($this->user->ID, $title, $text);
        $subject = "Request {$ticket}: rating system report";

        $message = Twig::factory('handler/report', [
            'Title' => $title,
            'Text'  => $text,
            'User'  => $this->user,
        ])->render();

        $headers = [
            'From: RatingSystem@no-reply.mmcs.sfedu.ru',
            'Reply-To: ' . $this->user->EMail,
//            'Content-Type: text/html; charset=UTF-8',
        ];

        mail($to, $subject, $message, implode("\n", $headers));

        $data['success'] = ($ticket > 0);
        $this->response->body(json_encode($data));
    }

    /** return int  number of created ticket */
    private function sendNewRequest($accountID, $title, $description) {
        $sql = "SELECT `CreateRequest`(:account, :title, :description) AS 'Num';";
        return DB::query(Database::SELECT, $sql)
            ->param(':account', (int) $accountID)
            ->param(':description', $description)
            ->param(':title', $title)
            ->execute()[0]['Num'];
    }
}
