<?php

class Controller_Office_Students extends Controller_Environment_Office
{
    public function action_index() {
        # todo: sub-menus
        $this->action_search();
    }

    public function action_search() {
        $this->twig->set([
            'Faculties'  => Model_Faculties::load(),
            'GradesList' => Model_Grades::loadAll()  # todo: ->as_array('Degree'),
        ])->set_filename(static::OFFICE . 'students/search');
    }

    public function action_transfer() {
        $this->twig->set([
            'SemestersList'   => Model_Semesters::loadAll(),
            'GradesList'      => Model_Grades::loadAll(),
            'CurrentSemester' => Model_System::$SemesterID
        ])->set_filename(static::OFFICE . 'students/transfer');
    }

    public function action_add() {
        $this->twig->set([
            'Faculties' => Model_Faculties::load(),
            'Grades'    => Model_Grades::loadAll()->as_array('Degree'),
        ])->set_filename(static::OFFICE . 'students/add');
    }

    public function action_upload() {
        $errors = [];

        if (!empty($_FILES['students']) && $this->request->method() == 'POST') {
            $file = $_FILES['students']['tmp_name'];
            $errors = FileParser::uploadStudents($file, $_POST['facultyID']);
        }

        $this->twig->set([
            'Errors'    => $errors,
            'Faculties' => Model_Faculties::load(),
        ])->set_filename(static::OFFICE . 'students/upload');
    }

    public function action_profile() {
        $id = $this->request->param('id');

        if (!$id) $this->redirect(Route::get('office:common')->uri());

        $student = Model_Student::load($id);

        $this->twig->set([
            'Profile' => $student,
            'Grades'  => Model_Grades::loadAll(),
            'Account' => Model_Account::with($student->AccountID),
            'Groups'  => Model_Faculty::with($student->FacultyID)->getGroups($student->GradeNum),
            # todo: Statuses, Student.Status
        ])->set_filename(static::OFFICE . 'students/profile');
    }
}
