<?php defined('SYSPATH') or die('No direct script access.');
 
class HTTP_Exception extends Kohana_HTTP_Exception {
 
    /**
     * Generate a Response for all Exceptions without a more specific override
     *
     * The user should see a nice error page, however, if we are in development
     * mode we should show the normal Kohana error page.
     *
     * @return Response
     */
    public function get_response()
    {
        // Lets log the Exception, Just in case it's important!
        Kohana_Exception::log($this);

        $twig = Twig::factory('errors/http');
        $twig->code = $this->getCode();
        $twig->message = $this->getMessage();
        $twig->link = URL::site('');
        $response = Response::factory()
            ->status($this->getCode())
            ->body($twig);

        return $response;
    }
}